<?php
/*
Plugin Name: Lidio WooCommerce Entegrasyonu
Description: Entegrasyon süreçlerinizi kolaylaştıracak çeşitli finansal enstrümanlar ile tahsilat süreçlerinizi pürüzsüzleştiriyor, ödeme sayfalarınızı dilediğiniz şekilde tasarlama imkânı sunuyoruz.
Version: 1.00
Plugin URI: 
Author: Lidio Ödeme Hizmetleri A.Ş.
Author URI: https://www.lidio.com/
License: Under GPL2   
*/
add_action('plugins_loaded', 'init_mobilexpress_gateway_class', 0);

function init_mobilexpress_gateway_class()
{
	if (!class_exists('WC_Payment_Gateway'))
		return;

	class mobilexpress extends WC_Payment_Gateway
	{
		
		function __construct(){
			$this->id = "mobilexpress";
			$this->method_title = "Lidio WooCommerce Entegrasyonu";
			$this->title = 'Kredi Kartı İle Ödeme';
			$this->icon = WP_PLUGIN_URL . "/" . plugin_basename(dirname(__FILE__)) . '/assets/bankalar.png';
			$this->has_fields       = true;
			$this->init_form_fields();
			$this->init_settings();
			$this->title           = $this->settings['title'];
			$this->description     = $this->settings['description'];
			add_action('woocommerce_receipt_' . $this->id, array($this, 'receipt_page'));
			if (is_admin()) {
				add_action('woocommerce_update_options_payment_gateways_' . $this->id, array($this, 'process_admin_options'));
			}
		}		

		public function admin_options()
		{
			echo '<h3>Lidio Sanalpos Modülü</h3>';
         echo '<table class="form-table">';
         $this->generate_settings_html();
         echo '</table>';
		}


		function init_form_fields()
      {
		
		$statuses = wc_get_order_statuses();
		
		$oderStatus = array();
		
		foreach ( $statuses as $status => $status_name ) {
			$oderStatus[$status] = esc_html( $status_name );
		}
  									
         $this->form_fields = array(
            'enabled'      => array(
                  'title'        => 'Aktif/Pasif',
                  'type'         => 'checkbox',
                  'label'        => 'Lidio Sanalpos Modülü nü aktif et?',
                  'default'      => 'no'),
            'title'        => array(
                  'title'        => 'Başlık:',
                  'type'         => 'text',
                  'description'  => '',
                  'default'      => 'Kredi Kartı İle Güvenli Ödeme'),
			
            'description'  => array(
                  'title'        => 'Açıklama:',
                  'type'         => 'text',
                  'description'  => '',
                  'default'      => 'Ödemelerinizi 3D Secure İle Güvenle Yapın.'),
			'islemTipi' => array(
				'title'       => 'İşlem Tipi',
				'type'        => 'select',
				'description' => '',
				'options'  => array(
								'1'=> 'Live',
								'0'=> 'Test',
					),
			),
			'MerchantCode'  => array(
                  'title'        => 'MerchantCode:',
                  'type'         => 'text',
                  'description'  => '',
                  'default'      => ''),
			'AuthorizationTest'  => array(
                  'title'        => 'Authorization (Test):',
                  'type'         => 'text',
                  'description'  => '',
                  'default'      => ''),
			'AuthorizationLive'  => array(
                  'title'        => 'Authorization (Live):',
                  'type'         => 'text',
                  'description'  => '',
                  'default'      => ''),	  	
			
			'odemeMetotlari' => array(
					'title'       => 'Ödeme Metotları',
					'type'        => 'multiselect',
					'description' => 'CTRL ile çoklu seçim yapabilirsiniz',
					'options'  => array(
									'NewCard'=> 'Kredi Kartı',
									'InstantLoan'=> 'Anında Kredi',
									'DirectWireTransfer'=> 'Anında Havale',
									'BKMExpress'=> 'BKM Express',
									'GarantiPay'=> 'GarantiPay',
									'MaximumMobil'=> 'MaximumMobil',
									
						),
				),
			'UseLoyaltyPoints' => array(
					'title'       => 'Kart Puan Kullanımı',
					'type'        => 'select',
					'description' => '',
					'options'  => array(
									'1'=> 'Evet',
									'0'=> 'Hayır',
						),
				),		
			'Use3DSecure' => array(
					'title'       => '3D Secure Kullanımı?',
					'type'        => 'select',
					'description' => '',
					'options'  => array(
									'Mandatory'=> 'Zorunlu',
									'Optional'=> 'Opsiyonel',
									'None'=> 'Hayır',
						),
				),
			'CardSave' => array(
					'title'       => 'Kart Kaydetme Seçeneği?',
					'type'        => 'select',
					'description' => '',
					'options'  => array(
									'PrepaymentOptional'=> 'Ödeme Öncesi Kaydet Opsiyonel',
									'PrepaymentMandatory'=> 'Ödeme Öncesi Kaydet Zorunlu',
									'PostPayment'=> 'Ödeme Sonrası Kaydet Opsiyonel',
						),
				),
			'RequestOTP' => array(
					'title'       => 'Kayıtlı Kart ile Ödemede SMS Onayı Istensin?',
					'type'        => 'select',
					'description' => '',
					'options'  => array(
									'None'=> 'Hayır',
									'Mandatory'=> 'Zorunlu',
 						),
				),
			'CVVOnay' => array(
					'title'       => 'Kayıtlı Kartlarda CVV Onayı Istensin?',
					'type'        => 'select',
					'description' => '',
					'options'  => array(
									'1'=> 'Evet',
									'0'=> 'Hayır',
						),
				),
			'partialPayment' => array(
					'title'       => 'Parçalı Ödeme Yapılabilsin?',
					'type'        => 'select',
					'description' => '',
					'options'  => array(
									'Optional'=> 'Evet',
									'None'=> 'Hayır',
 						),
				),
			'UseInstallment' => array(
					'title'       => 'Taksitli Ödeme Yapılabilsin?',
					'type'        => 'select',
					'description' => '',
					'options'  => array(
									'1'=> 'Evet',
									'0'=> 'Hayır',
						),
				),
			'paymentExtraConsent1' => array(
					'title'       => 'Ödeme Rıza Metni 1',
					'type'        => 'select',
					'description' => '',
					'options'  => array(
									'None'=> 'Hayır',
									'Optional'=> 'Opsiyonel',
									'Mandatory'=> 'Zorunlu',
						),
				),
			'paymentExtraConsent2' => array(
					'title'       => 'Ödeme Rıza Metni 2',
					'type'        => 'select',
					'description' => '',
					'options'  => array(
									'None'=> 'Hayır',
									'Optional'=> 'Opsiyonel',
									'Mandatory'=> 'Zorunlu',
						),
				),
			'cardSaveExtraConsent' => array(
					'title'       => 'Kart Kayıtta Ek Rıza Metni',
					'type'        => 'select',
					'description' => '',
					'options'  => array(
									'None'=> 'Hayır',
									'Optional'=> 'Opsiyonel',
									'Mandatory'=> 'Zorunlu',
						),
				),
				
			'siparisDurumu' => array(
				'title'       => 'Varsayılan Sipariş Durumu',
				'type'        => 'select',
				'description' => '',
				'options'  => $oderStatus
			),
			'ipnBasariliSiparisDurumu' => array(
				'title'       => 'Başarılı IPN Bildirimi Sonrası Sipariş Durumu (Sipariş Fraud Kontrolünden Geçti)',
				'type'        => 'select',
				'description' => '',
				'options'  => $oderStatus
			),	
			
			'ipnBasarisizSiparisDurumu' => array(
				'title'       => 'Başarısız IPN Bildirimi Sonrası Sipariş Durumu (Sipariş Fraud Kontrolünden Geçemedi)',
				'type'        => 'select',
				'description' => '',
				'options'  => $oderStatus
			),			
													
			);
      }

		function payment_fields(){
	
         if ( $this->description ) 
            echo wpautop(wptexturize($this->description));
      }

		public function process_payment($order_id)
		{
			global $woocommerce;
			$order = new WC_Order($order_id);
			
			
			
			$checkout_payment_url = $order->get_checkout_payment_url(true);
            return array(
                'result' => 'success',
                'redirect' => $checkout_payment_url,
            );
			
		}
		
		function receipt_page($orderid){
			
			$order = new WC_Order($orderid);
 			$checkout_url = $order->get_checkout_payment_url(true);
			
$data = array(
  "orderId"=> rand(10000,99999)."_".$orderid,
  "totalAmount"=> $order->get_total(),
  "currency"=> "TRY",
  "uiDesignInfo"=> array(
    "viewType"=> "Compact",
    "designType"=> "4",
  ),
  "customerInfo"=> array(
  	"customerId"=>$order->get_customer_id(),
    "email"=> $order->get_billing_email(),
    "name"=> $order->get_billing_first_name(). " ".$order->get_billing_last_name(),
    "phone"=> str_replace(" ","",substr($order->get_billing_phone(),-10)),
  ),
  "paymentInstrumentInfo"=> array(
    "card"=> array(
      "processType"=> "sales",
      "useInstallment"=> (bool)$this->settings['UseInstallment'],
      "useLoyaltyPoints"=> (bool)$this->settings['UseLoyaltyPoints'],
      "noAmex"=> true,
      "noDebitCard"=> true,
      "noForeignCard"=> true, 
    ),  
  ),
  "invoiceAddress"=> array(
    "contactName"=> !empty($order->get_billing_first_name()) ? $order->get_billing_first_name(). " ".$order->get_billing_last_name() : "BELIRTILMEDI",
    "country"=> !empty($order->get_billing_country()) ? $order->get_billing_country() : "BELIRTILMEDI",
	"city"=> !empty($order->get_billing_state()) ? WC()->countries->states[$order->get_billing_country()][$order->get_billing_state()] : "BELIRTILMEDI",
    "town"=> !empty($order->get_billing_city()) ? $order->get_billing_city() : "BELIRTILMEDI",
    "address"=> !empty($order->get_billing_address_1()) ? $order->get_billing_address_1()." ".$order->get_billing_address_2() : "BELIRTILMEDI",
    "postalCode"=> !empty($order->get_billing_postcode()) ? $order->get_billing_postcode() : "10000",
  ),
  "deliveryAddress"=> array(
    "contactName"=> !empty($order->get_shipping_first_name()) ? $order->get_shipping_first_name(). " ".$order->get_shipping_last_name() : $order->get_billing_first_name()." ".$order->get_billing_last_name(),
    "country"=> !empty($order->get_shipping_country()) ? $order->get_shipping_country() : $order->get_billing_country(),
	"city"=> !empty($order->get_shipping_state()) ? WC()->countries->states[$order->get_shipping_country()][$order->get_shipping_state()] : WC()->countries->states[$order->get_billing_country()][$order->get_billing_state()],
    "town"=> !empty($order->get_shipping_city()) ? $order->get_shipping_city() : $order->get_billing_city(),
    "address"=> !empty($order->get_shipping_address_1()) ? $order->get_shipping_address_1()." ".$order->get_shipping_address_2() : $order->get_billing_address_1()." ".$order->get_billing_address_2(),
    "postalCode"=> !empty($order->get_shipping_postcode()) ? $order->get_shipping_postcode() : "10000",
  ),
  "returnUrl"=> get_site_url()."/wp-content/plugins/mobilexpress-sanalpos-modulu/mobilexpressResult.php",
  "notificationUrl"=> get_site_url()."/wp-content/plugins/mobilexpress-sanalpos-modulu/mobilexpressIpn.php",
  "clientIp"=> getenv('REMOTE_ADDR'),
  "clientUserAgent"=> $_SERVER['HTTP_USER_AGENT'],
);

	
	foreach ( WC()->cart->get_cart() as $cart_item ) {
 	
			$data['basketItems'][] = array(
				'name'     => $cart_item['data']->get_title(),
				'unitPrice'    => $cart_item['data']->get_price(),
				'quantity' => $cart_item['quantity'],
				'criticalCategory' => "Other",
				'isParticipationBankingCompatible' => true,
			);
	}


			$digerTotal = $order->get_total() - $order->get_subtotal();

			 if ($digerTotal > 0) {
				$data['basketItems'][] = array(
					'name'     => "Kargo ve Vergi Ücretleri",
					'unitPrice'    => $digerTotal,
					'quantity' => 1,
					'criticalCategory' => "Other",
					'isParticipationBankingCompatible' => true,
				);
			} 
	
	$odemeMetotlari = array_values($this->settings['odemeMetotlari']);
	
	if($this->settings['CardSave'] != "None"){
		
		$data["paymentInstruments"][] = "StoredCard";
		
		$data["paymentInstrumentInfo"]["card"]["storedCard"]["threeDSecureMode"] = $this->settings['Use3DSecure'];
		$data["paymentInstrumentInfo"]["card"]["storedCard"]["customerIsLoggedIn"] = true;
		
		
		if($this->settings['RequestOTP'] == "Mandatory"){
			$data["paymentInstrumentInfo"]["card"]["storedCard"]["verificationMethods"] = array("OTP");
		}
		if($this->settings['CVVOnay'] == "1"){
			$data["paymentInstrumentInfo"]["card"]["storedCard"]["verificationMethods"] = array();
			$data["paymentInstrumentInfo"]["card"]["storedCard"]["verificationMethods"] = array("CVV");
		}
		
		if( $this->settings['RequestOTP'] == "Mandatory" and $this->settings['CVVOnay'] == "1"){
			$data["paymentInstrumentInfo"]["card"]["storedCard"]["verificationMethods"] = array();
			$data["paymentInstrumentInfo"]["card"]["storedCard"]["verificationMethods"] = array("OTPandCVV");
		}
	
	}
	
		if($this->settings['partialPayment'] == "Optional"){
			$data["partialPayment"]["mode"] = "Optional";
			$data["partialPayment"]["maxCount"] = "3";
		}
	
		if(in_array("NewCard",$odemeMetotlari)){
 			$data["paymentInstruments"][] = "NewCard";
			$data["paymentInstrumentInfo"]["card"]["newCard"]["threeDSecureMode"] = $this->settings['Use3DSecure'];
			$data["paymentInstrumentInfo"]["card"]["newCard"]["noCvv"] = false;
			$data["paymentInstrumentInfo"]["card"]["newCard"]["cardSaveOffer"] = $this->settings['CardSave'];
			
			$data["paymentInstrumentInfo"]["card"]["newCard"]["cardConsents"]["cardSaveExtraConsent1"] = $this->settings['cardSaveExtraConsent'];
			
			
		}
		if(in_array("InstantLoan",$odemeMetotlari)){
 			$data["paymentInstruments"][] = "InstantLoan";
			$data["paymentInstrumentInfo"]["instantLoan"] = array("bankAccountId"=> array());
		}
		if(in_array("BKMExpress",$odemeMetotlari)){
 			$data["paymentInstruments"][] = "BKMExpress";
			$data["paymentInstrumentInfo"]["card"]["bkmExpress"]["processType"] ="sales";
			
		}
		if(in_array("GarantiPay",$odemeMetotlari)){
 			$data["paymentInstruments"][] = "GarantiPay";
			$data["paymentInstrumentInfo"]["card"]["garantiPay"]["processType"] ="sales";
			
		}
		if(in_array("MaximumMobil",$odemeMetotlari)){
 			$data["paymentInstruments"][] = "MaximumMobil";
			$data["paymentInstrumentInfo"]["card"]["maximumMobil"]["processType"] ="sales";
			
		}
		
		if(in_array("DirectWireTransfer",$odemeMetotlari)){
 			$data["paymentInstruments"][] = "directWireTransfer";
			$data["paymentInstrumentInfo"]["directWireTransfer"] = array("bankAccountId"=> array());
			
		}
	
		$data["paymentConsents"]["paymentExtraConsent1"] = $this->settings['paymentExtraConsent1'];
		$data["paymentConsents"]["paymentExtraConsent2"] = $this->settings['paymentExtraConsent2'];
		
		 
	$data = json_encode($data);

	if($this->settings['islemTipi']){
		$url = "https://www.lidio.com/api/StartHostedPaymentProcess";
		$redir_url = "https://www.lidio.com/VPayment/VPayGateway.aspx";
		$MerchantCode = $this->settings['MerchantCode'];
		$Authorization = $this->settings['AuthorizationLive'];
	}else{
		$url = "https://test.lidio.com/api/StartHostedPaymentProcess";
		$redir_url = "https://test.lidio.com/VPayment/VPayGateway.aspx";
		$MerchantCode = $this->settings['MerchantCode'];
		$Authorization = $this->settings['AuthorizationTest'];
	}
$ch = curl_init();
curl_setopt($ch, CURLOPT_POST,1);
curl_setopt($ch, CURLOPT_URL,$url);
curl_setopt($ch, CURLOPT_SSL_VERIFYHOST,  FALSE);
curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
curl_setopt($ch, CURLOPT_TIMEOUT, 30);
curl_setopt($ch, CURLOPT_HTTPHEADER, array(
    "MerchantCode: ".$MerchantCode,
	"Authorization: ".$Authorization,
	"Content-Type: application/json",
  ));
	$result=curl_exec ($ch);
	$result = json_decode($result,true);
 	
	$resultCode = $result["result"];
	$resultMessage = $result["resultMessage"];
	$data = array();
	$errorMessage = "";
	$hostedUrl = "";
	
	if ($resultCode == 'Success'){
		$hostedUrl = $result["redirectURL"];
		if($this->settings['CardSave'] == "PostPayment"){
			WC()->session->set('redirectURL', $result["redirectURL"]);
		}
	  }else{
		  
		  $order->add_order_note( 'Mobilexpress Log: Time: '.date("Y-m-d H:i:s"). ' - OrderId:'.$orderid.' - URL: '.$url.' - Result: ' . $resultCode. ' - ResultDetail: - ResultMessage: '.$resultMessage);
		
		if ($resultCode == 'InvalidPhone') {
            $errorMessage = 'Geçersiz telefon numarası (5xx ile başlamalı ve 10 haneli olmalı)';
        } else if ($resultCode == 'InvalidEmail') {
            $errorMessage = 'Geçersiz email adresi';
        } else if ($resultCode == 'InvalidCustomerID') {
            $errorMessage = 'Geçersiz müşteri numarası';
        } else if ($resultCode == 'InvalidAmount') {
            $errorMessage = 'Geçersiz tutar';
        } else if ($resultCode == 'InvalidReturnURL') {
            $errorMessage = 'Geçersiz ReturnURL';
        } else if ($resultCode == 'AuthenticationError') {
            $errorMessage = 'Geçersiz api bilgileri (MerchantKey yada APIpassword hatalı';
        } else if ($resultCode == 'ServerError') {
            $errorMessage = 'Sunucu tarafında sorun oluştu. Mobilexpress ile iletişime geçiniz';
        } else {
            $errorMessage = 'Bilinmeyen bir sorun oluştu. Mobilexpress ile iletişime geçiniz';
        }
		
		$errorMessage = $errorMessage. " - (".$resultCode.")";
	  }
		
 		include (dirname(__FILE__).'/mobilexpressForm.php');	
		}
	}
	function mobilexpress($methods)
	{
		$methods[] = 'mobilexpress';
		return $methods;
	}

	add_filter('woocommerce_payment_gateways', 'mobilexpress');
}
